#include "command.h"
#include "loader.h"
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define inv_file "inv.txt"
#define inv_base_file "inv_base.txt"
#define combo_file "combos.txt"

#define MAX_BUF_LENGTH 1024
#define MAX_COMBO_LENGTH 1024

int main(int argc, char *argv[]) {
  hashmap *elements = hashmap_create();
  hashmap *inv = hashmap_create();

  char *command = calloc(MAX_BUF_LENGTH, sizeof(char));
  char *command_re = calloc(MAX_BUF_LENGTH, sizeof(char));
  char **sort_tmp = calloc(MAX_COMBO_LENGTH, sizeof(char **));

  load_elements(elements, combo_file, 0) ||
      load_elements(elements, "bin/" combo_file, 0);
  load_elements(inv, inv_base_file, 1) ||
      load_elements(inv, "bin/" inv_base_file, 1);

  load_elements(inv, inv_file, 1);

  printf("Welcome to Elemental on Command Line!\n");
  while (1) {
    // todo: separate into functions

    printf("\n");
    fgets(command, MAX_BUF_LENGTH - 1, stdin);
    int slashRan = slash_command(command, inv);
    if (slashRan)
      continue;

    int combos = get_command(command, command_re, sort_tmp);

    int failed = 0;
    for (int i = 0; i < combos; i++) {
      uintptr_t result;
      hashmap_get(inv, sort_tmp[i], strlen(sort_tmp[i]), &result);
      if (result != 1) {
        printf("You don't have %s.\n", sort_tmp[i]);
        failed = 1;
        continue;
      }
    }

    if (failed)
      continue;

    uintptr_t result;
    hashmap_get(elements, command_re, strlen(command_re), &result);

    if (result == 0) {
      printf("You didn't make anything.\n");
      continue;
    }

    char *res_str = (char *)result;

    hashmap_set(inv, res_str, strlen(res_str), (uintptr_t)1);
    printf("You made %s!\n", res_str);

    FILE *fptr;

    fptr = fopen(inv_file, "a");
    if (fptr == NULL)
      continue;
    fwrite(res_str, sizeof(char), strlen(res_str), fptr);
    fwrite("\n",sizeof(char),1,fptr);
    fclose(fptr);
  }

  // free(command);
}